﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.Modeling;
using Microsoft.VisualStudio.Modeling.Design;
using Microsoft.VisualStudio.Modeling.Diagrams;

namespace Company.ShapeContainer
{
    public partial class ExampleShape
    {
        protected override void Collapse()
        {
            base.Collapse();
            this.AbsoluteBounds = new RectangleD(this.Location, new SizeD(1, 1));
        }

        protected override void Expand()
        {
            base.Expand();
            this.AbsoluteBounds = new RectangleD(this.Location, new SizeD(3, 2));
        }

        public override bool AllowsChildrenToResizeParent
        {
            get
            {
                return true;
            }
        }

        public override SizeD MinimumResizableSize
        {
            get
            {
                return this.CalculateMinimumSizeBasedOnChildren();
            }
        }
    }
} 
