﻿<?xml version="1.0" encoding="utf-8"?>
<Dsl xmlns:dm0="http://schemas.microsoft.com/VisualStudio/2008/DslTools/Core" dslVersion="1.0.0.0" Id="d20d070f-3033-4c8a-a7ef-d2fd3bd29dcd" Description="Description for Company.ShapeContainer.ShapeContainer" Name="ShapeContainer" DisplayName="ShapeContainer" Namespace="Company.ShapeContainer" ProductName="ShapeContainer" CompanyName="Company" PackageGuid="86a090c8-07f9-4486-986b-19af1b482948" PackageNamespace="Company.ShapeContainer" xmlns="http://schemas.microsoft.com/VisualStudio/2005/DslTools/DslDefinitionModel">
  <Classes>
    <DomainClass Id="a476cc4f-b823-4f54-bc9f-9a139602df45" Description="The root in which all other elements are embedded. Appears as a diagram." Name="ExampleModel" DisplayName="Example Model" Namespace="Company.ShapeContainer">
      <ElementMergeDirectives>
        <ElementMergeDirective>
          <Notes>Creates an embedding link when an element is dropped onto a model. </Notes>
          <Index>
            <DomainClassMoniker Name="ExampleElement" />
          </Index>
          <LinkCreationPaths>
            <DomainPath>ExampleModelHasElements.Elements</DomainPath>
          </LinkCreationPaths>
        </ElementMergeDirective>
      </ElementMergeDirectives>
    </DomainClass>
    <DomainClass Id="16ae797a-3024-418c-b7b3-bc2c7cee0860" Description="Elements embedded in the model. Appear as boxes on the diagram." Name="ExampleElement" DisplayName="Example Element" Namespace="Company.ShapeContainer">
      <Properties>
        <DomainProperty Id="fd9905fb-b94a-4da5-950f-078acdde5c52" Description="Description for Company.ShapeContainer.ExampleElement.Name" Name="Name" DisplayName="Name" DefaultValue="" IsElementName="true">
          <Type>
            <ExternalTypeMoniker Name="/System/String" />
          </Type>
        </DomainProperty>
      </Properties>
      <ElementMergeDirectives>
        <ElementMergeDirective>
          <Index>
            <DomainClassMoniker Name="ExampleChild" />
          </Index>
          <LinkCreationPaths>
            <DomainPath>ExampleElementHasExampleChild.ExampleChild</DomainPath>
          </LinkCreationPaths>
        </ElementMergeDirective>
      </ElementMergeDirectives>
    </DomainClass>
    <DomainClass Id="19c74c3e-7f1d-41f3-bbe2-b25fb7f6fcda" Description="Description for Company.ShapeContainer.ExampleChild" Name="ExampleChild" DisplayName="Example Child" Namespace="Company.ShapeContainer">
      <Properties>
        <DomainProperty Id="3ebfc6e3-d1cd-4489-bc59-d51a627042a6" Description="Description for Company.ShapeContainer.ExampleChild.Name" Name="Name" DisplayName="Name" IsElementName="true">
          <Type>
            <ExternalTypeMoniker Name="/System/String" />
          </Type>
        </DomainProperty>
      </Properties>
    </DomainClass>
  </Classes>
  <Relationships>
    <DomainRelationship Id="a6d98e31-d771-40d8-b1bf-aafdffb08344" Description="Embedding relationship between the Model and Elements" Name="ExampleModelHasElements" DisplayName="Example Model Has Elements" Namespace="Company.ShapeContainer" IsEmbedding="true">
      <Source>
        <DomainRole Id="57881e00-da1d-4b0d-82ef-22d98373492f" Description="" Name="ExampleModel" DisplayName="Example Model" PropertyName="Elements" PropagatesCopy="PropagatesCopyToLinkAndOppositeRolePlayer" PropertyDisplayName="Elements">
          <RolePlayer>
            <DomainClassMoniker Name="ExampleModel" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="69a93c29-ed4b-4eac-90a7-56736d712276" Description="" Name="Element" DisplayName="Element" PropertyName="ExampleModel" Multiplicity="One" PropagatesDelete="true" PropertyDisplayName="Example Model">
          <RolePlayer>
            <DomainClassMoniker Name="ExampleElement" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
    <DomainRelationship Id="366f7980-abd1-44c6-bfd7-4b05b303d822" Description="Reference relationship between Elements." Name="ExampleElementReferencesTargets" DisplayName="Example Element References Targets" Namespace="Company.ShapeContainer">
      <Source>
        <DomainRole Id="7ac2019c-fda4-4b40-a9fc-5fbf151cb380" Description="Description for Company.ShapeContainer.ExampleRelationship.Target" Name="Source" DisplayName="Source" PropertyName="Targets" PropertyDisplayName="Targets">
          <RolePlayer>
            <DomainClassMoniker Name="ExampleElement" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="71ea3612-1edd-479b-a8c2-1fe1382a2fcc" Description="Description for Company.ShapeContainer.ExampleRelationship.Source" Name="Target" DisplayName="Target" PropertyName="Sources" PropertyDisplayName="Sources">
          <RolePlayer>
            <DomainClassMoniker Name="ExampleElement" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
    <DomainRelationship Id="93e89267-f6de-4906-bf80-fadeaaca1a95" Description="Description for Company.ShapeContainer.ExampleElementHasExampleChild" Name="ExampleElementHasExampleChild" DisplayName="Example Element Has Example Child" Namespace="Company.ShapeContainer" IsEmbedding="true">
      <Source>
        <DomainRole Id="90c0a444-bd4f-4c39-a791-2f3b53f49242" Description="Description for Company.ShapeContainer.ExampleElementHasExampleChild.ExampleElement" Name="ExampleElement" DisplayName="Example Element" PropertyName="ExampleChild" PropagatesCopy="PropagatesCopyToLinkAndOppositeRolePlayer" PropertyDisplayName="Example Child">
          <RolePlayer>
            <DomainClassMoniker Name="ExampleElement" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="af99018e-738e-4ff0-b609-71beb06e661b" Description="Description for Company.ShapeContainer.ExampleElementHasExampleChild.ExampleChild" Name="ExampleChild" DisplayName="Example Child" PropertyName="ExampleElement" Multiplicity="One" PropagatesDelete="true" PropertyDisplayName="Example Element">
          <RolePlayer>
            <DomainClassMoniker Name="ExampleChild" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
    <DomainRelationship Id="271c69ff-9ff9-4a66-b1b3-68b83ffcf09d" Description="Description for Company.ShapeContainer.ExampleChildReferencesTargetExampleChild" Name="ExampleChildReferencesTargetExampleChild" DisplayName="Example Child References Target Example Child" Namespace="Company.ShapeContainer">
      <Source>
        <DomainRole Id="fe4e0e33-a960-45ca-885f-7111d81e3859" Description="Description for Company.ShapeContainer.ExampleChildReferencesTargetExampleChild.SourceExampleChild" Name="SourceExampleChild" DisplayName="Source Example Child" PropertyName="TargetExampleChild" PropertyDisplayName="Target Example Child">
          <RolePlayer>
            <DomainClassMoniker Name="ExampleChild" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="d75a0013-288b-456c-bade-e25a09932074" Description="Description for Company.ShapeContainer.ExampleChildReferencesTargetExampleChild.TargetExampleChild" Name="TargetExampleChild" DisplayName="Target Example Child" PropertyName="SourceExampleChild" PropertyDisplayName="Source Example Child">
          <RolePlayer>
            <DomainClassMoniker Name="ExampleChild" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
  </Relationships>
  <Types>
    <ExternalType Name="DateTime" Namespace="System" />
    <ExternalType Name="String" Namespace="System" />
    <ExternalType Name="Int16" Namespace="System" />
    <ExternalType Name="Int32" Namespace="System" />
    <ExternalType Name="Int64" Namespace="System" />
    <ExternalType Name="UInt16" Namespace="System" />
    <ExternalType Name="UInt32" Namespace="System" />
    <ExternalType Name="UInt64" Namespace="System" />
    <ExternalType Name="SByte" Namespace="System" />
    <ExternalType Name="Byte" Namespace="System" />
    <ExternalType Name="Double" Namespace="System" />
    <ExternalType Name="Single" Namespace="System" />
    <ExternalType Name="Guid" Namespace="System" />
    <ExternalType Name="Boolean" Namespace="System" />
    <ExternalType Name="Char" Namespace="System" />
  </Types>
  <Shapes>
    <GeometryShape Id="a4ef7418-e9db-45ad-9267-ba5c687872e5" Description="Shape used to represent ExampleElements on a Diagram." Name="ExampleShape" DisplayName="Example Shape" Namespace="Company.ShapeContainer" FixedTooltipText="Example Shape" FillColor="242, 239, 229" OutlineColor="113, 111, 110" InitialWidth="2" InitialHeight="0.75" OutlineThickness="0.01" Geometry="Rectangle">
      <Notes>The shape has a text decorator used to display the Name property of the mapped ExampleElement.</Notes>
      <ShapeHasDecorators Position="Center" HorizontalOffset="0" VerticalOffset="0">
        <TextDecorator Name="NameDecorator" DisplayName="Name Decorator" DefaultText="NameDecorator" />
      </ShapeHasDecorators>
      <ShapeHasDecorators Position="InnerTopLeft" HorizontalOffset="0" VerticalOffset="0">
        <ExpandCollapseDecorator Name="ExpandCollapseDecorator" DisplayName="Expand Collapse Decorator" />
      </ShapeHasDecorators>
    </GeometryShape>
    <GeometryShape Id="6eefc604-25cc-4c26-8d86-4cecd0e2946a" Description="Description for Company.ShapeContainer.ExampleChildShape" Name="ExampleChildShape" DisplayName="Example Child Shape" Namespace="Company.ShapeContainer" FixedTooltipText="Example Child Shape" InitialWidth="0.2" InitialHeight="0.2" Geometry="Circle" />
  </Shapes>
  <Connectors>
    <Connector Id="fc99e59f-6808-4b59-973c-48f237f2d0e0" Description="Connector between the ExampleShapes. Represents ExampleRelationships on the Diagram." Name="ExampleConnector" DisplayName="Example Connector" Namespace="Company.ShapeContainer" FixedTooltipText="Example Connector" Color="113, 111, 110" TargetEndStyle="EmptyArrow" Thickness="0.01" />
    <Connector Id="252b477c-1250-462e-91f0-2cc5164c2918" Description="Description for Company.ShapeContainer.ExampleChildConnector" Name="ExampleChildConnector" DisplayName="Example Child Connector" Namespace="Company.ShapeContainer" FixedTooltipText="Example Child Connector" />
  </Connectors>
  <XmlSerializationBehavior Name="ShapeContainerSerializationBehavior" Namespace="Company.ShapeContainer">
    <ClassData>
      <XmlClassData TypeName="ExampleModel" MonikerAttributeName="" SerializeId="true" MonikerElementName="exampleModelMoniker" ElementName="exampleModel" MonikerTypeName="ExampleModelMoniker">
        <DomainClassMoniker Name="ExampleModel" />
        <ElementData>
          <XmlRelationshipData RoleElementName="elements">
            <DomainRelationshipMoniker Name="ExampleModelHasElements" />
          </XmlRelationshipData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="ExampleElement" MonikerAttributeName="name" SerializeId="true" MonikerElementName="exampleElementMoniker" ElementName="exampleElement" MonikerTypeName="ExampleElementMoniker">
        <DomainClassMoniker Name="ExampleElement" />
        <ElementData>
          <XmlPropertyData XmlName="name" IsMonikerKey="true">
            <DomainPropertyMoniker Name="ExampleElement/Name" />
          </XmlPropertyData>
          <XmlRelationshipData RoleElementName="targets">
            <DomainRelationshipMoniker Name="ExampleElementReferencesTargets" />
          </XmlRelationshipData>
          <XmlRelationshipData UseFullForm="true" RoleElementName="exampleChild">
            <DomainRelationshipMoniker Name="ExampleElementHasExampleChild" />
          </XmlRelationshipData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="ExampleModelHasElements" MonikerAttributeName="" SerializeId="true" MonikerElementName="exampleModelHasElementsMoniker" ElementName="exampleModelHasElements" MonikerTypeName="ExampleModelHasElementsMoniker">
        <DomainRelationshipMoniker Name="ExampleModelHasElements" />
      </XmlClassData>
      <XmlClassData TypeName="ExampleElementReferencesTargets" MonikerAttributeName="" SerializeId="true" MonikerElementName="exampleElementReferencesTargetsMoniker" ElementName="exampleElementReferencesTargets" MonikerTypeName="ExampleElementReferencesTargetsMoniker">
        <DomainRelationshipMoniker Name="ExampleElementReferencesTargets" />
      </XmlClassData>
      <XmlClassData TypeName="ExampleShape" MonikerAttributeName="" SerializeId="true" MonikerElementName="exampleShapeMoniker" ElementName="exampleShape" MonikerTypeName="ExampleShapeMoniker">
        <GeometryShapeMoniker Name="ExampleShape" />
      </XmlClassData>
      <XmlClassData TypeName="ExampleConnector" MonikerAttributeName="" SerializeId="true" MonikerElementName="exampleConnectorMoniker" ElementName="exampleConnector" MonikerTypeName="ExampleConnectorMoniker">
        <ConnectorMoniker Name="ExampleConnector" />
      </XmlClassData>
      <XmlClassData TypeName="ShapeContainerDiagram" MonikerAttributeName="" SerializeId="true" MonikerElementName="shapeContainerDiagramMoniker" ElementName="shapeContainerDiagram" MonikerTypeName="ShapeContainerDiagramMoniker">
        <DiagramMoniker Name="ShapeContainerDiagram" />
      </XmlClassData>
      <XmlClassData TypeName="ExampleChild" MonikerAttributeName="name" SerializeId="true" MonikerElementName="exampleChildMoniker" ElementName="exampleChild" MonikerTypeName="ExampleChildMoniker">
        <DomainClassMoniker Name="ExampleChild" />
        <ElementData>
          <XmlPropertyData XmlName="name" IsMonikerKey="true">
            <DomainPropertyMoniker Name="ExampleChild/Name" />
          </XmlPropertyData>
          <XmlRelationshipData UseFullForm="true" RoleElementName="targetExampleChild">
            <DomainRelationshipMoniker Name="ExampleChildReferencesTargetExampleChild" />
          </XmlRelationshipData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="ExampleElementHasExampleChild" MonikerAttributeName="" SerializeId="true" MonikerElementName="exampleElementHasExampleChildMoniker" ElementName="exampleElementHasExampleChild" MonikerTypeName="ExampleElementHasExampleChildMoniker">
        <DomainRelationshipMoniker Name="ExampleElementHasExampleChild" />
      </XmlClassData>
      <XmlClassData TypeName="ExampleChildReferencesTargetExampleChild" MonikerAttributeName="" SerializeId="true" MonikerElementName="exampleChildReferencesTargetExampleChildMoniker" ElementName="exampleChildReferencesTargetExampleChild" MonikerTypeName="ExampleChildReferencesTargetExampleChildMoniker">
        <DomainRelationshipMoniker Name="ExampleChildReferencesTargetExampleChild" />
      </XmlClassData>
      <XmlClassData TypeName="ExampleChildShape" MonikerAttributeName="" SerializeId="true" MonikerElementName="exampleChildShapeMoniker" ElementName="exampleChildShape" MonikerTypeName="ExampleChildShapeMoniker">
        <GeometryShapeMoniker Name="ExampleChildShape" />
      </XmlClassData>
      <XmlClassData TypeName="ExampleChildConnector" MonikerAttributeName="" SerializeId="true" MonikerElementName="exampleChildConnectorMoniker" ElementName="exampleChildConnector" MonikerTypeName="ExampleChildConnectorMoniker">
        <ConnectorMoniker Name="ExampleChildConnector" />
      </XmlClassData>
    </ClassData>
  </XmlSerializationBehavior>
  <ExplorerBehavior Name="ShapeContainerExplorer" />
  <ConnectionBuilders>
    <ConnectionBuilder Name="ExampleElementReferencesTargetsBuilder">
      <Notes>Provides for the creation of an ExampleRelationship by pointing at two ExampleElements.</Notes>
      <LinkConnectDirective>
        <DomainRelationshipMoniker Name="ExampleElementReferencesTargets" />
        <SourceDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="ExampleElement" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </SourceDirectives>
        <TargetDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="ExampleElement" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </TargetDirectives>
      </LinkConnectDirective>
    </ConnectionBuilder>
    <ConnectionBuilder Name="ExampleChildReferencesTargetExampleChildBuilder">
      <LinkConnectDirective>
        <DomainRelationshipMoniker Name="ExampleChildReferencesTargetExampleChild" />
        <SourceDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="ExampleChild" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </SourceDirectives>
        <TargetDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="ExampleChild" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </TargetDirectives>
      </LinkConnectDirective>
    </ConnectionBuilder>
  </ConnectionBuilders>
  <Diagram Id="e015ca65-cde1-4869-a05c-9658567081f9" Description="Description for Company.ShapeContainer.ShapeContainerDiagram" Name="ShapeContainerDiagram" DisplayName="Minimal Language Diagram" Namespace="Company.ShapeContainer">
    <Class>
      <DomainClassMoniker Name="ExampleModel" />
    </Class>
    <ShapeMaps>
      <ShapeMap>
        <DomainClassMoniker Name="ExampleElement" />
        <ParentElementPath>
          <DomainPath>ExampleModelHasElements.ExampleModel/!ExampleModel</DomainPath>
        </ParentElementPath>
        <DecoratorMap>
          <TextDecoratorMoniker Name="ExampleShape/NameDecorator" />
          <PropertyDisplayed>
            <PropertyPath>
              <DomainPropertyMoniker Name="ExampleElement/Name" />
            </PropertyPath>
          </PropertyDisplayed>
        </DecoratorMap>
        <GeometryShapeMoniker Name="ExampleShape" />
      </ShapeMap>
      <ShapeMap HasCustomParentElement="true">
        <DomainClassMoniker Name="ExampleChild" />
        <ParentElementPath>
          <DomainPath />
        </ParentElementPath>
        <GeometryShapeMoniker Name="ExampleChildShape" />
      </ShapeMap>
    </ShapeMaps>
    <ConnectorMaps>
      <ConnectorMap>
        <ConnectorMoniker Name="ExampleConnector" />
        <DomainRelationshipMoniker Name="ExampleElementReferencesTargets" />
      </ConnectorMap>
      <ConnectorMap>
        <ConnectorMoniker Name="ExampleChildConnector" />
        <DomainRelationshipMoniker Name="ExampleChildReferencesTargetExampleChild" />
      </ConnectorMap>
    </ConnectorMaps>
  </Diagram>
  <Designer CopyPasteGeneration="CopyPasteOnly" FileExtension="mydsl6" EditorGuid="3a0e4cd3-e30a-49e5-8a3b-bcdd6e568013">
    <RootClass>
      <DomainClassMoniker Name="ExampleModel" />
    </RootClass>
    <XmlSerializationDefinition CustomPostLoad="false">
      <XmlSerializationBehaviorMoniker Name="ShapeContainerSerializationBehavior" />
    </XmlSerializationDefinition>
    <ToolboxTab TabText="ShapeContainer">
      <ElementTool Name="ExampleElement" ToolboxIcon="resources\exampleshapetoolbitmap.bmp" Caption="ExampleElement" Tooltip="Create an ExampleElement" HelpKeyword="CreateExampleClassF1Keyword">
        <DomainClassMoniker Name="ExampleElement" />
      </ElementTool>
      <ConnectionTool Name="ExampleRelationship" ToolboxIcon="resources\exampleconnectortoolbitmap.bmp" Caption="ExampleRelationship" Tooltip="Drag between ExampleElements to create an ExampleRelationship" HelpKeyword="ConnectExampleRelationF1Keyword">
        <ConnectionBuilderMoniker Name="ShapeContainer/ExampleElementReferencesTargetsBuilder" />
      </ConnectionTool>
      <ElementTool Name="ElementChild" ToolboxIcon="Resources\ExampleShapeToolBitmap.bmp" Caption="ElementChild" Tooltip="Element Child" HelpKeyword="ElementChild">
        <DomainClassMoniker Name="ExampleChild" />
      </ElementTool>
      <ConnectionTool Name="ExampleChildRelationShipe" ToolboxIcon="Resources\ExampleConnectorToolBitmap.bmp" Caption="ExampleChildRelationShipe" Tooltip="Example Child Relation Shipe" HelpKeyword="ExampleChildRelationShipe">
        <ConnectionBuilderMoniker Name="ShapeContainer/ExampleChildReferencesTargetExampleChildBuilder" />
      </ConnectionTool>
    </ToolboxTab>
    <Validation UsesMenu="false" UsesOpen="false" UsesSave="false" UsesLoad="false" />
    <DiagramMoniker Name="ShapeContainerDiagram" />
  </Designer>
  <Explorer ExplorerGuid="72418034-e94e-4b96-b855-b2af2ff5d94d" Title="ShapeContainer Explorer">
    <ExplorerBehaviorMoniker Name="ShapeContainer/ShapeContainerExplorer" />
  </Explorer>
</Dsl>