﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.Modeling.Diagrams;

namespace Company.ConnectionPoints
{
    public partial class ExampleShape
    {
        public override bool HasConnectionPoints
        {
            get
            {
                return true;
            }
        }

        public override void EnsureConnectionPoints(LinkShape link)
        {
            if (this.ConnectionPoints == null || this.ConnectionPoints.Count == 0)
            {
                double x, y;

                x = AbsoluteBoundingBox.Left + AbsoluteBoundingBox.Width  / 2;
                y = AbsoluteBoundingBox.Top;
                this.CreateConnectionPoint(new PointD(x, y));

                y = AbsoluteBoundingBox.Bottom;
                this.CreateConnectionPoint(new PointD(x, y));

                x = AbsoluteBoundingBox.Left;
                y = AbsoluteBoundingBox.Top + AbsoluteBoundingBox.Height / 2;
                this.CreateConnectionPoint(new PointD(x, y));

                x = AbsoluteBoundingBox.Right;
                y = AbsoluteBoundingBox.Top + AbsoluteBoundingBox.Height / 2;
                this.CreateConnectionPoint(new PointD(x, y));


            }
        }

    }
}
